// Command.cpp,v 1.2 2003/04/03 20:36:20 pradeep Exp

#include "Command.h"

#include "ace/Log_Msg.h"
#include "tao/corba.h"

ACE_RCSID(lib, TAO_Command, "$id$")

TAO_NS_Command::TAO_NS_Command (void)
  :next_ (0), command_ (INVALID)
{
}

TAO_NS_Command::~TAO_NS_Command ()
{
}

void
TAO_NS_Command::init (ACE_Arg_Shifter& /*arg_shifter*/)
{
  // default: do nothing.
}

void
TAO_NS_Command::next (TAO_NS_Command* command)
{
  this->next_ = command;
}

void
TAO_NS_Command::execute (ACE_ENV_SINGLE_ARG_DECL)
{
  if (this->command_ == INVALID)
    {
      ACE_DEBUG ((LM_DEBUG, "Invalid command: %s\n", this->get_name ()));
    }
  else
    {
      ACE_DEBUG ((LM_DEBUG, "Executing command: %s\n", this->get_name ()));

      ACE_TRY
        {
          this->execute_i (ACE_ENV_SINGLE_ARG_PARAMETER);
          ACE_TRY_CHECK;
        }
      ACE_CATCHANY
        {
          ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,
                               ACE_LIB_TEXT("Exception running command\n"));
        }
      ACE_ENDTRY;
    }

  if (this->next_)
    this->next_->execute (ACE_ENV_SINGLE_ARG_PARAMETER);
}
